### Pipeline still can be speed up using 'changed'
### and other conditions (specifying cases when we can just skip some jobs)
### e.g. not test if code was not changed
### not rebuild/test/deploy image, if it already exists on registry (like if it's just merge dev into test, with same code)

variables:
  IMAGE: $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA


default:
  tags:
    - docker
    - cafedra

build:
  stage: build
  image: docker
  services:
    - docker:dind
  #    - docker:18.09.7-dind  #specifying 18.09.7 version is needed to run on kubernetes runner
  #  variables:
  #    DOCKER_HOST: tcp://localhost:2375   #required to work on kubernetes runners
  only:
    refs:
      - dev
  script:
    - echo $CI_REGISTRY_PASSWORD | docker login -u $CI_REGISTRY_USER $CI_REGISTRY --password-stdin
    - docker build --platform=amd64 -t $IMAGE .
    - docker push $IMAGE


deploy:
  stage: deploy
  image:
    name: bitnami/kubectl:latest
    entrypoint: [ "" ]
  only:
    refs:
      - dev
  script:
    - sed -i -e "s~rozklad:latest~$IMAGE~g" ./ci-cd/kube/backend-deploy.yaml

    # Note that in order for KUBE_CONFIG to propagate when building not for dev,
    # you must add other branches (test, prod, ...) to protected branches
    # in settings -> repository -> protected branches
    - echo -n $KUBE_CONFIG | base64 -d > $HOME/.kube/config
    - kubectl apply -f ./ci-cd/kube/
